(function ($) {
    'use strict';
    $(document).ready(function () {

        //we delay the init to avoid conflicts with plugin that hook on the select2 classes and create conflicts
        setTimeout(function () {
            $("#font").select2({allowClear: true});
        }, 500);

        load_select2();

        function load_select2(container)
        {
            if (typeof container == "undefined")
                container = "";
            $(container + " select.o-select2").each(function () {
//                console.log($(this));
                $(this).select2({allowClear: true});
            });
        }

        // Gérer l'affichage des opérateurs
        function hideoption(group, rule, valeur) {
            var h = 0;
            $.each(operators, function () {
                var op = $('#lsd-pricing-group_' + group + '_rule_' + rule + '_' + h).val();
                if (valeur === 'if_selected_font') {
                    if (op !== "==" && op !== "!=") {
                        $('option#lsd-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'none');
                    }
                } else {
                    $('option#lsd-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'block');
                }
                h++;
            });
        }

        /**
         * Function to automatically update the operators field
         */

        function lsd_update_rule_operator(table_length, group_index, new_rule_index) {
            if (typeof (group_index) !== 'undefined' && typeof (new_rule_index) !== 'undefined') {
                var valeur = $('#lsd-group_' + group_index + '_rule_' + new_rule_index + '_param   option:selected').val();
                hideoption(group_index, new_rule_index, valeur);
                $('#lsd-group_' + group_index + '_rule_' + new_rule_index + '_param').change(function () {
                    valeur = $(this).val();
                    hideoption(group_index, new_rule_index, valeur);
                    $('#lsd-pricing-group_' + group_index + '_rule_' + new_rule_index + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                });
            } else {
                var i = 0;
                while (i < table_length) {
                    var body_length = $('table.lsd-rules-table.widefat tbody')[i].getElementsByTagName("tr").length;
                    var j = 0;
                    while (j < body_length) {
                        var valeur = $('#lsd-group_' + i + '_rule_' + j + '_param   option:selected').val();
                        hideoption(i, j, valeur);
                        $('#lsd-group_' + i + '_rule_' + j + '_param').change(function () {
                            var param_id = $(this).attr('id');
                            var par_tab = param_id.split('_');
                            var group = par_tab[1];
                            var rule = par_tab[3];
                            valeur = $(this).val();
                            hideoption(group, rule, valeur);
                            $('#lsd-pricing-group_' + group + '_rule_' + rule + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                        });
                        j++;
                    }
                    i++;
                }
            }
        }
        //on document ready update rule operators
        var table_length = $('table.lsd-rules-table.widefat').length;
        lsd_update_rule_operator(table_length);

        /*
         * 
         * auto load font data
         */
        $(document).on('change', '#font', function () {
            var name = $('#font  option:selected').text();
            var url = $('#font   option:selected').val();
            $('.font_auto_name').val(name);
            $('.font_auto_url').val(url);

        });
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * 
         * Newsletter
         */
        $(document).on("click", "#lsd-dismiss", function () {
            $.post(
                    lsd_ajaxurl,
                    {
                        action: "lsd_hide_notice",
                    },
                    function (data) {
                        if (data === "ok") {
                            $('#lsd-subscription-notice').hide();
                        }
                    })
                    .fail(function (xhr, status, error) {
                        alert(error);
                    });

        });

        $(document).on("click", "#lsd-subscribe", function () {
            $("#lsd-subscribe-loader").show();
            $("#lsd-subscribe").attr("disabled", true);
            $("#lsd-subscribe").addClass('disabled');
            if (!$('#o_user_email').val()) {
                alert('No email found. Please add an email address to subscribe.');
                $("#lsd-subscribe-loader").hide();
                $("#lsd-subscribe").attr("disabled", false);
                $("#lsd-subscribe").removeClass('disabled');
            } else {
                var email = $('#o_user_email').val();
                var lsd_subscription_nonce = $('#lsd_subscription_nonce').val();
                $.post(
                        lsd_ajax_object.lsd_ajaxurl,
                        {
                            action: "lsd_subscribe",
                            email: email,
                            lsd_subscription_nonce:lsd_subscription_nonce
                        },
                        function (data) {
                            if (data === "true") {
                                $("#lsd-subscribe-loader").hide();
                                $('#lsd-subscription-notice').hide();
                                $('#lsd-subscription-success-notice').show();
                            } else {
                                $("#lsd-subscribe-loader").hide();
                                $("#lsd-subscribe").attr("disabled", false);
                                $("#lsd-subscribe").removeClass('disabled');
                                alert(data);
                            }
                        })
                        .fail(function (xhr, status, error) {
                            $("#lsd-subscribe-loader").hide();
                            $("#lsd-subscribe").attr("disabled", false);
                            $("#lsd-subscribe").removeClass('disabled');
                            alert(error);
                        });
            }

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * add font file
         */

        $(document).on("click", ".o-add-font-file", function (e) {
            e.preventDefault();
            var uploader = wp.media({
                title: 'Please set the font',
                button: {
                    text: "Select font(s)"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var new_rule_index = $(".font_style_table tbody tr").length;
                                    var font_tpl = $("#lsd-font-tpl").val();
                                    var tpl = font_tpl.replace(/{index}/g, new_rule_index);
                                    $('.font_style_table tbody').prepend(tpl);
                                    $('#file_data_' + new_rule_index).find("input[type=hidden]").val(attachment.id);
                                    $('#file_data_' + new_rule_index).parent().find(".media-name").html(attachment.filename);
                                }
                        );
                    })
                    .open();
        });
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * Remove font
         */
        $(document).on("click", ".o-remove-font-file", function (e) {
            e.preventDefault();
            $(this).parent().find("input[type=hidden]").val("");
            $(this).parent().parent().find(".media-name").html("");
            $(this).parent().parent().remove();
        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * canvas background color
         */
        $(document).on("change", ".lsd-bg-type", function (e)
        {
            get_bg_fields_based_on_type();

        });

        if ($('.lsd-bg-type').length > 0) {
            setTimeout(
                    function () {
                        get_bg_fields_based_on_type();
                    }, 1000);
        }

        function get_bg_fields_based_on_type()
        {
            $("[class*='show-if-canvas-']").hide();
            var selected_value = $('.lsd-bg-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-canvas-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-canvas-colorpicker').show();
            } else {
                $('.show-if-canvas-colors').hide();
                $('.show-if-canvas-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text color type
         */
        $(document).on("change", ".lsd-text-color-type", function (e)
        {
            get_text_colors_fields_based_on_type();

        });

        if ($('.lsd-text-color-type').length > 0) {
            setTimeout(
                    function () {
                        get_text_colors_fields_based_on_type();
                    }, 1000);
        }

        function get_text_colors_fields_based_on_type()
        {
            $("[class*='show-if-text-']").hide();
            var selected_value = $('.lsd-text-color-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-text-colors').show();
            } else {
                $('.show-if-text-colorpicker').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * Rules
         */
        $(document).on("click", ".lsd-add-rule", function (e)
        {
            var new_rule_index = $(".lsd-rules-table tr").length;
            var group_index = $(this).data("group");
            var raw_tpl = $("#lsd-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            $(this).parents(".lsd-rules-table").find("tbody").append(tpl2);
            $(this).parents(".lsd-rules-table").find(".a_price").attr("rowspan", new_rule_index + 1);
            //update rule operators
            var table_length = $('table.lsd-rules-table.widefat').length;
            lsd_update_rule_operator('',group_index,new_rule_index);
        });

        $(document).on("click", ".lsd-add-group", function (e)
        {
            var new_rule_index = 0;
            var group_index = $(".lsd-rules-table").length;
            var raw_tpl = $("#lsd-first-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            var html = '<table class="lsd-rules-table widefat"><tbody>' + tpl2 + '</tbody></table>';
            $(".lsd-rules-table-container").append(html);
            //update rule operators
            var table_length = $('table.lsd-rules-table.widefat').length;
            lsd_update_rule_operator('',group_index,new_rule_index);
        });

        $(document).on("click", ".lsd-remove-rule", function (e)
        {
            var nb_rules = $(".lsd-rules-table tr").length;
            $(this).parents(".lsd-rules-table").find(".a_price").attr("rowspan", nb_rules - 1);
            $(this).parents("tr").remove();

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * output format ------------------------------------------------------------------------
         */
        function get_output_fields_based_on_format()
        {
            $("[class*='show-if-']").hide();
            var selected_value = $('.config-output-format input:checked').val();
//            console.log(selected_value);
            if (selected_value.indexOf("pdf") >= 0)
            {
                $('.show-if-pdf').show();
                $('.hide-if-pdf').hide();
            } else
            {
                $('.show-if-pdf').hide();
                $('.hide-if-pdf').show();
            }

            if (selected_value.indexOf("jpg") >= 0)
                $('.show-if-jpg').show();
            else
                $('.show-if-jpg').hide();

            //Zip output
            $(".show-if-zip").hide();
            var zip = $('.zip-output input:checked').val();
            if (zip == 'yes')
                $('.show-if-zip').show();
            else
                $('.show-if-zip').hide();
        }


        $(document).on("change", ".config-output-format input, .zip-output input", function (e)
        {
            get_output_fields_based_on_format();

        });

        if ($('.config-output-format').length) {
            get_output_fields_based_on_format();
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * font type
         */
        $('#lsd_fonts_selector').select2();

        $(document).on("change", ".lsd-fonts-type", function (e)
        {
            get_fonts_field_based_on_type();

        });

        if ($('.lsd-fonts-type').length) {
            get_fonts_field_based_on_type();
        }

        function get_fonts_field_based_on_type()
        {
            $("[class*='show-if-fonts-global-']").hide();
            var selected_value = $('.lsd-fonts-type input:checked').val();

            if (selected_value.indexOf("no") >= 0)
            {
                $('.show-if-fonts-global-no').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * load colorpicker ------------------------------------------------------------------------
         */
        $(document).on("click", ".o-color-btn", function () {
            console.log("clicked");
            load_color_picker();
        });

        function load_color_picker() {
            $('.o-color').each(function (index, element)
            {
                var e = $(this);
                var initial_color = e.val();
                e.css("border-left", "35px solid " + initial_color);
                $(this).parent().find('.o-color-btn').ColorPicker({
                    color: initial_color,
                    onShow: function (colpkr) {
                        $(colpkr).fadeIn(500);
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        e.css("border-left", "35px solid #" + hex);
                        e.val("#" + hex);
                        e.trigger("input");
                    }
                });
            });
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /**
         * Redirection on the new ticket page once the user clicks on Request a feature on the menu
         */
        $(document).on("click", function (event) {
            var text = $(event.target).text();
            if ("Request a feature" === text) {
                event.preventDefault();
                window.open('https://orionorigin.freshdesk.com/support/tickets/new');
            }

        });
        
        /**
         * Show the modal box once the user clicks on the view design button
         */
        $('.lsd-view-design').on('click', function(){
            var modal_id = $(this).attr('data-target');
            $(modal_id+'.lsd-modal').omodal("show");
        });
        
        //Activate license.
        $("#lsd-activate").on("click", function (){
            var code = 0;
            request_registration(code);
        });

        function request_registration(code) {
            $("#lsd-spinner").css('display', 'inline-block');
            $.post(
                    lsd_ajax_object.lsd_ajaxurl,
                    {
                        action: "lsd_activate_license",
                        code: code
                    },
                    function (data) {
                        $("#lsd-spinner").css('display', 'none');
                        switch (data) {
                            case "licence_key_used_on_different_site":
                                if (confirm("This licence key has been used for another website. Do you want to use it anyway? (this will deactivate the previous website activated)")) {
                                    var code = 1;
                                    request_registration(code);
                                } else {
                                    $('#lsd-license-message').html("<p>Operation cancelled.</p>");
                                }
                                break;
                            case "200":
                                alert("Activation succeded! Your product is now activated");
                                document.location.reload(true);
                                break;
                            default:
                                alert(data);
                                $('#lsd-license-message').html("<p>" + data + "</p>");
                                break;
                        }
                    })
                    .fail(function (xhr, status, error) {
                        $("#lsd-spinner").css({display: "none"});
                        $('#lsd-license-message').html("<p>Activation failed due to a network error. Please, retry later. </p>");
                        alert("Activation failed due to a network error. Please, retry later.");
                    });
        }


    });

})(jQuery);
