<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-lsd-editor
 *
 * @author HL
 */
class LSD_Editor {

    public $item_id;
    public $root_item_id;
    public $lsd_product;

    public function __construct($item_id) {
        if ($item_id) {
            $this->item_id = $item_id;
            $this->lsd_product = new LSD_Product($item_id);
            $this->root_item_id = $this->lsd_product->root_product_id;
        }
    }

    public function get_editor() {
        global $lsd_settings;

        ob_start();
        $product = wc_get_product($this->item_id);
        if (!$product) {
            esc_attr_e('Error: Invalid product: ', 'lsd');
            echo esc_attr($this->item_id);
            echo '<br>';
            esc_attr_e('1- Is your customization page defined as homepage?', 'lsd');
            echo '<br>';
            esc_attr_e('2- Is your customization page defined as one of woocommerce pages?', 'lsd');
            echo '<br>';
            esc_attr_e('3- Does the product you are trying to customize exists and is published in your shop?', 'lsd');
            echo '<br>';
            esc_attr_e('4- Are you accessing this page from one of the product designer buttons?', 'lsd') . '<br>';
            return;
        }

        // if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1' && $_SERVER['REMOTE_ADDR'] != '::1') {
        if (!get_option('lsd-license-key')) {
            echo '<br><h2>';
            esc_attr_e('You have not activated your license yet. Please, activate it in order to use this plugin.', 'lsd');
            echo '</h2><br>';
            return;
        } 
        //}

        $lsd_metas = $this->lsd_product->settings;

        lsd_init_canvas_vars($lsd_metas, $product, $this);
        $ui_options = get_proper_value($lsd_settings, 'lsd-ui-options', array());
        $skin = get_proper_value($ui_options, 'skin', 'LSD_Default_Skin');

        $editor = new $skin($this, $lsd_metas);

        $raw_output = $editor->lsd_display();
        //Escaping output.
        $allowed_tags = lsd_allowed_tags();
        wp_nonce_field('lsd_generate_design', 'lsd_generate_design_nonce');
        echo wp_kses($raw_output, $allowed_tags);
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

}
