<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-lsd-default-skin
 *
 */
class LSD_Default_Skin {

	public $editor;
	public $lsd_metas;

	public function __construct( $editor_obj, $lsd_metas ) {
		if ( $editor_obj ) {
			$this->editor    = $editor_obj;
			$this->lsd_metas = $lsd_metas;
		}
	}

	/*
	 * Header block
	 */
	public function lsd_get_editor_header() {
		?>
		<a href="#" class="lsd-tool-header" data-slide-index="0">
			<span class="ti-text lsd-tool-icon "></span>
			<span class="lsd-tool-title">1. Enter your text</span>
		</a>
		<a href="#" class="lsd-tool-header" data-slide-index="1">
			<span class="ti-palette lsd-tool-icon"></span>
			<span class="lsd-tool-title">2. Style your text</span>
		</a>
		<a href="#" class="lsd-tool-header" data-slide-index="2">
			<span class="ti-shopping-cart lsd-tool-icon"></span>
			<span class="lsd-tool-title">3. Add to cart</span>
		</a>
		<?php
	}

	/*
	 * Text block
	 */
	public function lsd_get_text_block() {
		?>
		<div class="lsd-row">
			<textarea class="lsd-textarea">Your text</textarea>
			<div class="lsd-row">
				<div class="lsd-col left-col">
					<input id="lsd-reverse-cut" type="checkbox" name="reverse-cut" value="" class="lsd-checkbox"><br>
					<label for="reverse-cut" class="lsd-checkbox-label">Reverse cut</label>
					<span class="lsd-what-is-this">?</span>
				</div>
				<div class="lsd-col right-col">
					<button id="lsd-update-preview" class="lsd-button">Update preview</button>
				</div>
			</div>
		</div>

		<div class="lsd-row">
			<div class="lsd-col left-col">
				<span>Text alignment<span>
						</div>
						<div class="lsd-col right-col">
							<input type="hidden" data-alignment="left" id="lsd-text-alignment" readonly>
							<span class="lsd-alignments ti-align-left"></span>
							<span class="lsd-alignments ti-align-center"></span>
							<span class="lsd-alignments ti-align-right"></span>
						</div>
						</div>

						<div class="lsd-row">
							<div class="lsd-col left-col">
								<span>Character spacing<span>
										</div>
										<div class="lsd-col right-col">
											<div class="lsd-range-slider">
												<span class="ti-minus lsd-char-minus"></span>
												<input class="lsd-range-slider__range" id="lsd-spacing-range" type="range" value="1" min="1" max="30" step="1">
												<span class="ti-plus lsd-char-plus"></span>
											</div>
										</div>
										</div>
										<?php
	}

	/*
	 * Style block
	 */
	public function lsd_get_editor_style_block() {
										$config_metas     = $this->lsd_metas;
										$use_global_fonts = get_proper_value( $config_metas, 'global-fonts', 'yes' );
										$default_width    = get_proper_value( $config_metas, 'canvas-w', 144 );
										$default_height   = get_proper_value( $config_metas, 'canvas-h', 30 );
		if ( 'yes' === $use_global_fonts ) {
			$fonts = lsd_add_ttfurl_to_font_array( get_option( 'lsd-fonts' ) );
		} else {
			$selected_fonts = get_proper_value( $config_metas, 'selected-fonts', 'yes' );
			$fonts          = lsd_retrieve_fonts_data( $selected_fonts );
		}
										?>
										<div class="lsd-row">
											<div class="lsd-col left-col w20">
												<span>Font</span>
											</div>
											<div class="lsd-col right-col w80">
												<div class="lsd-font-picker">
													<div id="lsd-font-input-cover"></div>
													<input type="text" name="font" value="" data-minwidth="" data-minheight="" data-fonturl="" class="lsd-text-input" id="lsd-font-input" readonly>
													<ul class="hidden">
														<?php
														if ( ! empty( $fonts ) ) {
															foreach ( $fonts as $font ) {
																$ttf = '';
																if ( isset( $font['ttf'][0] ) ) {
																	$ttf = $font['ttf'][0];
																}
																echo "<li style='font-family:" . esc_attr( $font[0] ) . ";' data-ttf='" . esc_url( $ttf ) . "' data-minwidth='" . esc_attr( $font[3] ) . "' data-minheight='" . esc_attr( $font[4] ) . "' data-fonturl='" . esc_attr( $font[1] ) . "'>" . esc_attr( $font[0] ) . '</li>';
															}
														}
														?>
													</ul>
												</div>
												<div id="lsd-font-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.font">
													<div class="lsd-color"></div>
													<input type="hidden" name="font-color" value="" data-color="" id="lsd-font-color" readonly>
													<div class="lsd-color-palette-container">
														<div class="lsd-color-palette font">
															<div class="lsd-color-palette-content"></div>
														</div>
													</div>
												</div>
											</div>
										</div>

										<div id="lsd-canvas-color-block" class="lsd-row">
											<div class="lsd-col left-col">
												<span>Canvas color</span>
											</div>
											<div class="lsd-col right-col">
												<div id="lsd-canvas-color-picker" class="lsd-color-picker" data-tooltip-content=".lsd-color-palette.canvas">
													<div class="lsd-color"></div>
													<input type="hidden" name="canvas-color" value="" data-color="" id="lsd-canvas-color" readonly>
													<div class="lsd-color-palette-container">
														<div class="lsd-color-palette canvas">
															<div class="lsd-color-palette-content"></div>
														</div>
													</div>
												</div>
											</div>
										</div>

										<div class="lsd-row">
											<div class="lsd-row">
												<div class="lsd-col left-col">
													<span>Canvas size</span>
													<span class="lsd-what-is-this">?</span>
												</div>
												<div class="lsd-col right-col">
																									<input type="text" name="canvas-custom-width" id="canvas-custom-width" value="<?php echo esc_attr( $default_width ); ?>" class="lsd-text-input size-input">
													<span>X</span>
													<input type="text" name="canvas-custom-height" id="canvas-custom-height" value="<?php echo esc_attr( $default_height ); ?>" class="lsd-text-input size-input">
												</div>
											</div>
											<div class="lsd-row">
												<div class="lsd-col right-col w100">
													<span>(width x height)</span>
												</div>
											</div>
										</div>
										<div class="lsd-row">
											<button id="update-canvas-size" class="lsd-button">Update</button>
										</div>
		<?php
	}

	/*
	 * Action block
	 */
	public function lsd_get_editor_action_block() {
		?>
										<div class="lsd-row">
											<div class="lsd-col left-col w40">
												<span>Quantity<span>
														</div>
														<div class="lsd-col w60">
															<div class="lsd-quantity-container">
																<span class="ti-minus lsd-qty-minus"></span>
																<input class="lsd-quantity-field" name="quantity" type="number" value="1" min="1" step="1">
																<span class="ti-plus lsd-qty-plus"></span>
															</div>
														</div>
														</div>
														<div class="lsd-row">
															<div class="lsd-price-title">Price</div>
															<div class="lsd-price-container" id="lsd-price">
																$29.79
															</div>
														</div>
														<div class="lsd-row">
																													<button id="lsd-add-to-cart" data-id="<?php echo esc_attr( $this->editor->item_id ); ?>" class="lsd-button">Add to cart</button>
														</div>
		<?php
	}

	/*
	 * Editing area block
	 */
	public function lsd_get_editing_area() {
		$config_metas           = $this->lsd_metas;
		$canvas_w               = get_proper_value( $config_metas, 'canvas-w', 144 );
		$canvas_h               = get_proper_value( $config_metas, 'canvas-h', 30 );
		$canvas_dimensions_unit = get_proper_value( $config_metas, 'canvas-dimensions-unit', 'mm' );
		?>
			<div id="lsd-canvas-width">
							<span class="size-w"> <?php echo esc_attr( $canvas_w . $canvas_dimensions_unit ); ?> </span>
			</div>
			<div id="lsd-canvas-height">
				<span class="size-h"><?php echo esc_attr( $canvas_h . $canvas_dimensions_unit ); ?></span>
			</div>
			<div id="lsd-editor"></div>
		<?php
	}

	/*
	 * footer block
	 */
	public function lsd_get_editor_footer() {
		?>
														<div class="lsd-row">
															<div class="lsd-col left-col w80">
																<span class="lsd-footer-text">
																	Please note: The surface colour is for illustrative purposes only and won't be produced.
																	Self-adhesive vinyl letters are individually cut and come pre-spaced with application tape applied.
																</span>
															</div>
															<div class="lsd-col right-col w20">
																<input id="show-guides" type="checkbox" name="show-guides" value="" class="lsd-checkbox">
																<label for="show-guides" class="lsd-checkbox-label">Show guides</label>
																<span class="lsd-what-is-this">?</span>
															</div>
														</div>
		<?php
	}

	/*
	 * Main function that handles the full display
	 */
	public function lsd_display() {
		global $lsd_settings;
		$lsd_settings = apply_filters( 'lsd_global_settings', $lsd_settings );
		ob_start();
		$this->register_styles();
		$this->register_scripts();
		?>

														<div class='lsd-container o-wrap '>
															<!--editor header-->
															<div id="lsd-header">
		<?php
		$this->lsd_get_editor_header();
		?>
															</div>

															<!--tool boxes-->
															<div id="lsd-tools-container">

																<!--text block -->
																<div class="lsd-tool-block">
		<?php $this->lsd_get_text_block(); ?>
																</div>

																<!--style block -->
																<div class="lsd-tool-block">
		<?php $this->lsd_get_editor_style_block(); ?>
																</div>

																<!--cart block -->
																<div class="lsd-tool-block">
		<?php $this->lsd_get_editor_action_block(); ?>
																</div>

															</div>
															<!--debug area-->
															<div id="lsd-admin-debug"></div>
															<!--editing area-->
															<div id="lsd-editing-area">
		<?php $this->lsd_get_editing_area(); ?>
															</div>


															<!--footer block -->
															<div id="lsd-footer">
		<?php $this->lsd_get_editor_footer(); ?>
															</div>
														</div>
			<div id="lsd-debug"></div>								
		<?php
		$output = ob_get_clean();
		return $output;
	}

	/*
	 * Register scripts
	 */
	private function register_scripts() {
		wp_enqueue_script( 'lsd-editor-js', LSD_URL . 'public/js/editor.js', array( 'jquery' ), LSD_VERSION, false );
		wp_enqueue_script( 'lsdd-accounting-js', LSD_URL . 'public/js/accounting.min.js', array( 'jquery' ), LSD_VERSION, false );
		wp_enqueue_script( 'lsd-block-UI-js', LSD_URL . 'public/js/blockUI/jquery.blockUI.min.js', array( 'jquery' ), LSD_VERSION, false );

		lsd_register_scripts();
	}

	/*
	 * Register styles files
	 */
	private function register_styles() {
		lsd_register_fonts( $this->lsd_metas );
	}

}
