var LSD_EDITOR = (function ($, lsd_editor) {
  'use strict';
  var lsd_editor = {};
  lsd_editor.canvas = {};

  $(document).ready(function () {

    if (typeof lsd != 'undefined')
    {
      accounting.settings = {
        currency: {
          symbol: lsd.currency, // default currency symbol is '$'
          format: lsd.price_format, // controls output: %s = symbol, %v = value/number (can be object: see below)
          decimal: lsd.decimal_sep, // decimal point separator
          thousand: lsd.thousand_sep, // thousands separator
          precision: lsd.nb_decimals   // decimal places
        },
        number: {
          precision: lsd.nb_decimals, // default precision on numbers is 0
          thousand: lsd.thousand_sep,
          decimal: lsd.decimal_sep
        }
      }
    }

    // if (typeof additionnal_rules != 'undefined') {
    //   $.each(additionnal_rules,function (key,rule) {
    //     var verify_result = lsd_verify_condition(rule.rules);
    //     if (verify_result) {
    //       additionnal_price = additionnal_price + parseInt(rule.a_price);
    //     }
    //   });
    // }

    //disable context menu for image
    $("#lsd-editing-area").bind("contextmenu", function (e) {
      return false;
    });

    /*
    * function to update the price (input and span)
    */

    function lsd_update_price() {
      var additionnal_rules = lsd.pricing_rules;
      var basing_price = parseInt(lsd.product_price);
      var text_palette_tpl_price = lsd.text_palette_tpl_pricing;
      var bg_palette_tpl_price = lsd.bg_palette_tpl_pricing;
      var text_color_price = 0;
      var bg_color_price = 0;
      var additionnal_price_per_item = 0;
      var additionnal_price_on_design = 0;

      //retrieve text color
      var text_color = $('#lsd-font-color').attr("data-color");
      if(typeof text_palette_tpl_price !== 'undefined') {
        $.each(text_palette_tpl_price,function(index,text){
          if(text.hex === text_color){
            if($.isNumeric( parseInt(text.price) ) ){
              text_color_price = parseInt(text.price);
            }
          }
        });
      }

      //retrieve canvas color
      var canvas_color = $('#lsd-canvas-color').attr("data-color");
      if (typeof bg_palette_tpl_price !== 'undefined') {
        $.each(bg_palette_tpl_price,function(index,bg){
          if(bg.hex === canvas_color){
            if($.isNumeric( parseInt(bg.price) ) ){
              bg_color_price = parseInt(bg.price);
            }
          }
        });
      }

      if (typeof additionnal_rules !== 'undefined') {
        $.each(additionnal_rules,function (key,rule) {
          var verify_result = lsd_verify_condition(rule);
          if (verify_result) {
            if (verify_result.verify) {
              additionnal_price_per_item = additionnal_price_per_item + parseInt(verify_result.additionnal_price);
              if($.isNumeric( parseInt(rule.a_price) ) ){
                if (rule.scope === 'design') {
                  additionnal_price_on_design = additionnal_price_on_design + parseInt(rule.a_price);
                }
              }
            }
          }
        });
      }
      var qty = parseInt($(".lsd-quantity-field").val());
      var total = ( parseInt(basing_price) + parseInt(text_color_price) + parseInt(bg_color_price) + parseInt(additionnal_price_per_item) +  parseInt(additionnal_price_on_design)) * parseInt(qty);
      $("#lsd-price").html(accounting.formatMoney(total));
    }

    function lsd_verify_condition(rule) {
      if (typeof rule != 'undefined') {
        var comparaison_result = [];
        $.each(rule.rules, function( index, this_rule ) {
          if (typeof this_rule != 'undefined' && this_rule.param != 'undefined') {
            //retrieve the text in the textarea
            var enteredText = $('.lsd-textarea').val();
            var formattedText = enteredText.replace(/\n/g, '<br/>');
            switch (this_rule.param) {
              case "txt_nb_chars":
              if (typeof formattedText != 'undefined') {
                var text_size = formattedText.length;
                comparaison_result.push(lsd_operator(this_rule.operator,text_size,this_rule.value));
              }
              break;
              case "txt_nb_lines":
              if (typeof formattedText != 'undefined') {
                var text_nb_line = formattedText.split("<br/>").length;
                comparaison_result.push(lsd_operator(this_rule.operator,text_nb_line,this_rule.value));
              }
              break;
              case "if_canvas_square_unit":
              var canvas_w = parseInt($('#canvas-custom-width').val());
              var canvas_h = parseInt($('#canvas-custom-height').val());
              if (typeof canvas_w != 'undefined' && typeof canvas_h != 'undefined') {
                var canvas_square = canvas_h * canvas_w;
                comparaison_result.push(lsd_operator(this_rule.operator,canvas_square,this_rule.value));
              }
              break;
              case "if_selected_font":
              //retrieve the selected font
              rule.scope = 'design';
              var font = $('#lsd-font-input').val();
              if (typeof font != 'undefined') {
                comparaison_result.push(lsd_operator(this_rule.operator,font,this_rule.value));
              }
              break;
              case "if_char_spacing":
              //letter spacing
              var space = parseInt($("#lsd-spacing-range").val());
              if (typeof space != 'undefined') {
                comparaison_result.push(lsd_operator(this_rule.operator,space,this_rule.value));
              }
              break;
              default:
              comparaison_result = comparaison_result;
              break;
            }
          }
        });
        var verify = 0;
        $.each(comparaison_result, function (key,value) {
          if (value.result) {
            verify++;
          }
        });
        var additionnal_price_per_item = 0;
        var result = [];
        result['verify'] = false;

        if (verify === comparaison_result.length) {
          result['verify'] = true;
          $.each(comparaison_result, function (key,value) {
            if (rule.scope === 'item' && typeof(value.remaining_number) != 'undefined') {
              additionnal_price_per_item = additionnal_price_per_item + (value.remaining_number * rule.a_price);
            }else {
              additionnal_price_per_item = additionnal_price_per_item + 0;
            }
          });
          result['additionnal_price'] = additionnal_price_per_item;
        }
        return result;
      }
    }

    function lsd_operator(operator,giving_value,rule_value) {
      var data = [];
      if (operator === ">") {
        data['result'] = giving_value > rule_value;
        if (giving_value > rule_value) {
          data['remaining_number'] = giving_value - rule_value;
        }
        return data;
      }else if (operator === ">=") {
        data['result'] = giving_value >= rule_value;
        if (giving_value >= rule_value) {
          data['remaining_number'] = (giving_value - rule_value) + 1;
        }
        return data;
      }else if (operator === "<") {
        data['result'] = giving_value < rule_value;
        if (giving_value < rule_value) {
          data['remaining_number'] = rule_value - giving_value;
        }
        return data;
      }else if (operator === "<=") {
        data['result'] = giving_value <= rule_value;
        if (giving_value < rule_value) {
          data['remaining_number'] = (rule_value - giving_value) + 1;
        }
        return data;
      }else if (operator === "==") {
        data['result'] = giving_value == rule_value;
        if ($.isNumeric( parseInt(giving_value) ) && $.isNumeric( parseInt(rule_value) ) && giving_value === rule_value) {
          data['remaining_number'] = giving_value;
        }
        return data;
      }else {
        data['result'] = giving_value != rule_value;
        if ($.isNumeric( parseInt(giving_value) ) && $.isNumeric( parseInt(rule_value) ) && giving_value !== rule_value) {
          data['remaining_number'] = giving_value;
        }
        return data;
      }
    }

    /*
    * Function to retrieve image from user selection
    */
    function lsd_retrieve_built_image() {
      //lsd_update_dimensions();
      var data = lsd_retrieve_designer_data();
      lsd_update_price();
      if (isNaN(data.width) || isNaN(data.height)) {
        $("#lsd-admin-debug").html("Wrong dimensions given");
        $("#lsd-editor").html("");
      } else {
        $.blockUI({message: lsd.translated_strings.loading_msg});
        var lsd_generate_design_nonce = $('#lsd_generate_design_nonce').val();
        $.post(
          lsd_ajax_object.lsd_ajax_url,
          {
            action: "lsd_generate_image",
            data: data,
            lsd_generate_design_nonce: lsd_generate_design_nonce
          },
          function (response) {
            $.unblockUI();
            $("#lsd-editor").html("");
            var retrievedData = JSON.parse(response);

            if (retrievedData.image) {
              $("#canvas-custom-width").prop('disabled', false);
              $("#canvas-custom-height").prop('disabled', false);
              setTimeout(function () {
                window.URL.revokeObjectURL(retrievedData.image);
                $("#lsd-editor").append("<img src='" + retrievedData.image + "' />");
              }, 10);
              $("#lsd-canvas-width").css("width", retrievedData.width);
              $("#lsd-admin-debug").append(retrievedData.message);
              $.unblockUI();
            } else {
              $("#lsd-admin-debug").html(retrievedData.message);
              $.unblockUI();
            }
          });
        }
      }

      //function to retrieve all data from the designer
      function lsd_retrieve_designer_data() {
        var data = {};
        //retrieve the text in the textarea
        var enteredText = $('.lsd-textarea').val();
        var formattedText = enteredText.replace(/\n/g, '<br/>');
        data["text"] = formattedText;

        //retrieve the selected font
        var font = $('#lsd-font-input').val();
        data["font"] = font;

        //retrieve the selected font url
        var fonturl = $('#lsd-font-input').attr('data-fonturl');
        data["font-url"] = fonturl;

        //retrieve the selected font ttf
        data["font-ttf"] = $('#lsd-font-input').attr('data-ttf');

        var canvas_w = $('#canvas-custom-width').val();
        var canvas_h = $('#canvas-custom-height').val();

        data['width'] = $("#lsd-editing-area").width();
        data['height'] = Math.round((canvas_h * data['width']) / canvas_w);

        data['custom-width'] = $("#canvas-custom-width").val();
        data['custom-height'] = $("#canvas-custom-height").val();

        //retrieve text color
        var text_color = $('#lsd-font-color').attr("data-color");
        data['text_color'] = text_color;

        //retrieve canvas color
        var canvas_color = $('#lsd-canvas-color').attr("data-color");
        if (canvas_color === "") {
          canvas_color = 'transparent';
        }
        data['canvas_color'] = canvas_color;
        data['unit'] = lsd.canvas_dimensions_unit;

        //verify if reverse is checked
        if ($('#lsd-reverse-cut').prop('checked')) {
          data['reverse'] = "true";
        } else {
          data['reverse'] = "false";
        }

        //data['ratio'] = lsd.keep_ratio;

        //alignment
        data['alignment'] = $('#lsd-text-alignment').attr("data-alignment");

        //letter spacing
        data['spacing'] = $("#lsd-spacing-range").val();
        return data;
      }


      /*
      *
      * function to get the optimal dimensions off the canvas
      */
      function get_optimal_dimensions() {
        var canvas_w = $('#canvas-custom-width').val();
        var canvas_h = $('#canvas-custom-height').val();

        if (lsd.keep_ratio === "yes") {
          if (canvas_w === "" && canvas_h !== "") {
            var ratio = lsd.canvas_w / lsd.canvas_h;
            canvas_w = Math.ceil(parseFloat(canvas_h) * ratio);

          } else if (canvas_w !== "" && canvas_h === "") {
            var ratio = lsd.canvas_h / lsd.canvas_w;
            canvas_h = Math.ceil(parseFloat(canvas_w) * ratio);

          } else {
            canvas_w = lsd.canvas_w;
            canvas_h = lsd.canvas_h;
          }
        }

        console.log(canvas_w, canvas_h);
        return [canvas_w, canvas_h];
      }

      /*
      * function to update the dimensions (input and span)
      */
      function lsd_update_dimensions() {
        var data = get_optimal_dimensions();
        var width = parseFloat(data[0]);
        var height = parseFloat(data[1]);

        //retrieve the text in the textarea
        var enteredText = $('.lsd-textarea').val();
        var formattedText = enteredText.replace(/\n/g, '<br/>');
        var lines = formattedText.split("<br/>");
        var lineCount = lines.length;
        var maxletter = 0;
        var i;
        for (i = 0; i < lineCount; i++) {
          if (maxletter < lines[i].length) {
            maxletter = lines[i].length;
          }
        }
        var letter_min_width = $('#lsd-font-input').attr('data-minwidth');
        var letter_min_height = $('#lsd-font-input').attr('data-minheight');

        if (letter_min_width && letter_min_height) {
          var min_width = letter_min_width * maxletter;
          var min_height = letter_min_height * lineCount;

          if (width < min_width && height >= min_height) {
            var message = "<div class='lsd-front-message'>The minimum width required for this font is " + min_width + lsd.canvas_dimensions_unit + " (" + letter_min_width + " " + lsd.canvas_dimensions_unit + "/ letter * " + maxletter + "). Yours is " + width + " " + lsd.canvas_dimensions_unit + ".</div>";
            $("#lsd-add-to-cart").prop("disabled", true);
          } else if (width >= min_width && height < min_height) {
            var message = "<div class='lsd-front-message'>The minimum height required for this font is " + min_height + lsd.canvas_dimensions_unit + " (" + letter_min_height + " " + lsd.canvas_dimensions_unit + "/ letter * " + lineCount + "). Yours is " + height + " " + lsd.canvas_dimensions_unit + ".</div>";
            $("#lsd-add-to-cart").prop("disabled", true);
          } else if (width < min_width && height < min_height) {
            var message = "<div class='lsd-front-message'>The minimum height required for this font is " + min_height + lsd.canvas_dimensions_unit + " (" + letter_min_height + " " + lsd.canvas_dimensions_unit + "/ letter * " + lineCount + "). Yours is " + height + " " + lsd.canvas_dimensions_unit + ". The minimum width required for this font is " + min_width + " " + lsd.canvas_dimensions_unit + " (" + letter_min_width + " " + lsd.canvas_dimensions_unit + "/ letter * " + maxletter + "). Yours is " + width + " " + lsd.canvas_dimensions_unit + ".</div>";
            $("#lsd-add-to-cart").prop("disabled", true);
          } else {
            var message = "";
            $("#lsd-add-to-cart").prop("disabled", false);
          }

          $("#lsd-admin-debug").html("").html(message);
        }
        $("#lsd-canvas-width").find("span").html(width + lsd.canvas_dimensions_unit);
        $("#lsd-canvas-height").find("span").html(height + lsd.canvas_dimensions_unit);
        $('#canvas-custom-width').val(width);
        $('#canvas-custom-height').val(height);

        $("#canvas-custom-width").attr('value', width);
        $("#canvas-custom-height").attr('value', height);

        $("#canvas-custom-width").prop('disabled', false);
        $("#canvas-custom-height").prop('disabled', false);
      }

      /*
      *
      * end of the functions set------------------------------------------------------
      */


      /*
      * When page is ready, update the preview image
      */
      setTimeout(function () {
        $("#lsd-update-preview").click();
      }, 5);

      /*
      * initialize default values
      */

      //font
      $('#lsd-font-input').attr("value", $('.lsd-font-picker ul li').first().text());
      $('#lsd-font-input').attr("data-fonturl", $('.lsd-font-picker ul li').first().attr("data-fonturl"));
      $('#lsd-font-input').attr("data-minwidth", $('.lsd-font-picker ul li').first().attr("data-minwidth"));
      $('#lsd-font-input').attr("data-minheight", $('.lsd-font-picker ul li').first().attr("data-minheight"));
      $('#lsd-font-input').attr("data-ttf", $('.lsd-font-picker ul li').first().attr("data-ttf"));

      //text color
      if (lsd.text_palette_type === "colors") {
        $('#lsd-font-color-picker .lsd-color').css('background-color', lsd.text_palette_tpl[0]);
        $('#lsd-font-color').attr("data-color", lsd.text_palette_tpl[0]);
        var default_text_color = lsd.text_palette_tpl[0];
      }

      if (lsd.text_palette_type === "colorpicker") {
        $('#lsd-font-color-picker .lsd-color').css('background-color', lsd.text_default_color);
        $('#lsd-font-color').attr("data-color", lsd.text_default_color);
        var default_text_color = lsd.text_default_color;
      }

      //canvas color
      if (lsd.bg_palette_type === "colors") {
        $('#lsd-canvas-color-picker .lsd-color').css('background-color', lsd.bg_palette_tpl[0]);
        $('#lsd-canvas-color').attr("data-color", lsd.bg_palette_tpl[0]);
        var default_bg_color = lsd.bg_palette_tpl[0];
      }

      if (lsd.bg_palette_type === "colorpicker") {
        $('#lsd-canvas-color-picker .lsd-color').css('background-color', lsd.bg_default_color);
        $('#lsd-canvas-color').attr("data-color", lsd.bg_default_color);
        var default_bg_color = lsd.bg_default_color;
      }
      /*
      * end ---------------------------------------------------------------------------------------
      */
      /*
      * Color picker for text
      */
      //control the stext color setting
      if (lsd.text_palette_type === "colors") {
        var showTextPaletteOnly = true;
        var showTextPalette = true;
      } else {
        var showTextPaletteOnly = false;
        var showTextPalette = false;
      }

      $('#lsd-font-color-picker .lsd-color-palette-content').spectrum({
        move: function (color) {
          $('#lsd-font-color').attr("data-color", color.toHexString());
          $('#lsd-font-color-picker .lsd-color').css('background-color', color);

        },
        change: function (color) {
        },
        flat: true,
        preferredFormat: "name",
        showInput: true,
        showAlpha: false,
        showPaletteOnly: showTextPaletteOnly,
        color: lsd.text_default_color,
        clickoutFiresChange: true,
        showPalette: showTextPalette,
        palette: lsd.text_palette_tpl,
      });
      /*
      * end ---------------------------------------------------------------------------
      */


      /*
      * Color picker for background
      */
      //control the setting choosed for the background color
      if (lsd.bg_palette_type === "colors") {
        var showBgPaletteOnly = true;
        var showBgPalette = true;
      } else if (lsd.bg_palette_type === "colorpicker") {
        var showBgPaletteOnly = false;
        var showBgPalette = false;
      } else {
        $("#lsd-canvas-color-block").hide();
      }

      $('#lsd-canvas-color-picker .lsd-color-palette-content').spectrum({
        move: function (color) {
          $('#lsd-canvas-color-picker .lsd-color').css('background-color', color);
          $('#lsd-canvas-color').attr("data-color", color.toHexString());
        },
        change: function () {
        },
        flat: true,
        preferredFormat: "name",
        showInput: true,
        showAlpha: false,
        showPaletteOnly: showBgPaletteOnly,
        color: default_bg_color,
        clickoutFiresChange: true,
        showButtons: true,
        showPalette: showBgPalette,
        palette: lsd.bg_palette_tpl,
      });

      /*
      * end ---------------------------------------------------------------------------------
      */


      //position the tooltip
      $('.lsd-color-picker').tooltipster({
        side: 'bottom',
        trigger: 'click',
        interactive: true,
      });


      //check if user is typing in the width box and disable the typing for the height box
      $(document).on("keydown", "#canvas-custom-width", function () {
        if (lsd.keep_ratio === "yes") {
          $("#canvas-custom-height").val("");
          $("#canvas-custom-height").prop('disabled', true);
        }

      });
      //check if user is typing in the width box and disable the typing for the height box
      $(document).on("keydown", "#canvas-custom-height", function () {
        if (lsd.keep_ratio === "yes") {
          $("#canvas-custom-width").val("");
          $("#canvas-custom-width").prop('disabled', true);
        }
      });

      //update preview on check reverse checkbox
      $(document).on("change", "#lsd-reverse-cut, #lsd-spacing-range", function () {
        setTimeout(function () {
          $("#lsd-update-preview").click();
        }, 10);
      });



      $(document).on("click", "#update-canvas-size, .lsd-char-plus, .lsd-char-minus", function () {
        setTimeout(function () {
          $("#lsd-update-preview").click();
        }, 10);
      });

      //initial dimensions update after dimension has been entered
      var typingTimer;
      var doneTypingInterval = 1000;
      var $input = $("#canvas-custom-width, #canvas-custom-height");

      //on keyup, start the countdown
      $input.on('keyup', function () {
        clearTimeout(typingTimer);
        typingTimer = setTimeout(doneTyping, doneTypingInterval);
      });

      //on keydown, clear the countdown
      $input.on('keydown', function () {
        clearTimeout(typingTimer);
      });

      //user is "finished typing," do something
      function doneTyping() {
        setTimeout(function () {
          lsd_update_dimensions();
          $("#lsd-update-preview").click();
        }, 10);
      }


      //call the function if any update on the interface occurs
      $(document).on("click", "#lsd-update-preview", function () {
        lsd_retrieve_built_image();
      });

      /*
      * Handle text alignement
      */
      //left
      $(document).on("click", ".ti-align-left", function () {
        $('#lsd-text-alignment').attr("data-alignment", "left");
        //#000000
        $('.ti-align-left').css('color', '#000000');
        $('.ti-align-right').css('color', '#999');
        $('.ti-align-center').css('color', '#999');
        lsd_retrieve_built_image();
      });

      //right
      $(document).on("click", ".ti-align-right", function () {
        $('#lsd-text-alignment').attr("data-alignment", "right");
        $('.ti-align-left').css('color', '#999');
        $('.ti-align-right').css('color', '#000000');
        $('.ti-align-center').css('color', '#999');
        lsd_retrieve_built_image();
      });

      //center
      $(document).on("click", ".ti-align-center", function () {
        $('#lsd-text-alignment').attr("data-alignment", "center");
        $('.ti-align-left').css('color', '#999');
        $('.ti-align-right').css('color', '#999');
        $('.ti-align-center').css('color', '#000000');
        lsd_retrieve_built_image();
      });


    });
    return lsd_editor;
  }(jQuery, LSD_EDITOR));
