(function ($) {
    'use strict';
    $(document).ready(function () {

        $(".single_variation_wrap").on("show_variation", function (event, variation) {
// Fired when the user selects all the required dropdowns / attributes
// and a final variation is selected / shown
            var variation_id = $("input[name='variation_id']").val();
            if (variation_id)
            {
                $(".lsd-buttons-wrap-variation").hide();
                $(".lsd-buttons-wrap-variation[data-id='" + variation_id + "']").show();
            }
        });
        var fontList = $('.lsd-font-picker input[type="text"]').next('ul');
        $('#lsd-font-input-cover').on('click', function () {

            if (fontList.hasClass('hidden'))
                fontList.removeClass('hidden');
            else
                fontList.addClass('hidden');
        });
        $('.lsd-font-picker ul li').on('click', function () {
            $('#lsd-font-input').attr("value", $(this).text() );
            $('#lsd-font-input').attr("data-fonturl", $(this).attr("data-fonturl"));
            $('#lsd-font-input').attr("data-minwidth", $(this).attr("data-minwidth"));
            $('#lsd-font-input').attr("data-minheight", $(this).attr("data-minheight"));
            $('#lsd-font-input').attr("data-ttf", $(this).attr("data-ttf"));

            fontList.addClass('hidden');
            setTimeout(function () {
                    $("#lsd-update-preview").click();
                }, 1000);
        });
        $(document).mouseup(function (e) {
            var container = $('.lsd-font-picker');
            // if the target of the click isn't the container nor a descendant of the container
            if (!container.is(e.target) && container.has(e.target).length === 0)
            {
                fontList.addClass('hidden');
            }
        });
        $(document).on('click', '.lsd-quantity-container span', function (e) {
            e.preventDefault();
            // Get values
            var $qty = $(".lsd-quantity-field");
            var currentVal = parseFloat($qty.val());
            var max = parseFloat($qty.attr('max'));
            var min = parseFloat($qty.attr('min'));
            var step = $qty.attr('step');
            // Format values
            if (!currentVal || currentVal === '' || currentVal === 'NaN')
                currentVal = 0;
            if (max === '' || max === 'NaN')
                max = '';
            if (min === '' || min === 'NaN')
                min = 0;
            if (step === 'any' || step === '' || step === undefined || parseFloat(step) === 'NaN')
                step = 1;
            // Change the value
            if ($(this).is('.lsd-qty-plus')) {

                if (max && (max == currentVal || currentVal > max)) {
                    $qty.val(max);
                } else {
                    $qty.val(currentVal + parseFloat(step));
                }

            } else {

                if (min && (min == currentVal || currentVal < min)) {
                    $qty.val(min);
                } else if (currentVal > 0) {
                    $qty.val(currentVal - parseFloat(step));
                }

            }
        });

        //update spacing slider value
        $(document).on('change', '#lsd-spacing-range', function() {
            $("#lsd-spacing-range").attr( "value", $(this).val() );
        });

        $(document).on('click', '.lsd-range-slider span', function (e) {
            e.preventDefault();
            // Get values
            var $charSpacing = $(".lsd-range-slider__range");
            var currentVal = parseFloat($charSpacing.val());
            var max = parseFloat($charSpacing.attr('max'));
            var min = parseFloat($charSpacing.attr('min'));
            var step = $charSpacing.attr('step');
            // Format values
            if (!currentVal || currentVal === '' || currentVal === 'NaN')
                currentVal = 0;
            if (max === '' || max === 'NaN')
                max = '';
            if (min === '' || min === 'NaN')
                min = 0;
            if (step === 'any' || step === '' || step === undefined || parseFloat(step) === 'NaN')
                step = 1;
            // Change the value
            if ($(this).is('.lsd-char-plus')) {

                if (max && (max == currentVal || currentVal > max)) {
                    $charSpacing.val(max);
                } else {
                    $charSpacing.val(currentVal + parseFloat(step));
                }

            } else {

                if (min && (min == currentVal || currentVal < min)) {
                    $charSpacing.val(min);
                } else if (currentVal > 0) {
                    $charSpacing.val(currentVal - parseFloat(step));
                }

            }
            $("#lsd-spacing-range").attr( "value", $("#lsd-spacing-range").val() );
        });

        if (window.matchMedia("(min-width: 320px) and (max-width: 780px)").matches) {

            var slider = $('#lsd-tools-container').bxSlider({
                pagerCustom: '#lsd-header',
                controls: false,
                infiniteLoop: false,
                touchEnabled: false,
                onSliderLoad: function () {
                    // $(".VPC_ln_Skin .components-slider").css("visibility", "visible");
                }
            });
        }

                //function to retrieve all data from the designer
        function lsd_retrieve_designer_data() {
            var data = {};
            //retrieve the text in the textarea
            var enteredText = $('.lsd-textarea').val();
            var formattedText = enteredText.replace(/\n/g, '<br/>');
            data["text"] = formattedText;

            //retrieve the selected font
            var font = $('#lsd-font-input').val();
            data["font"] = font;

            //retrieve the selected font url
            var fonturl = $('#lsd-font-input').attr('data-fonturl');
            data["font-url"] = fonturl;

            //retrieve the selected font ttf
            var fontTtf = $('#lsd-font-input').attr('data-ttf');
            data["font-ttf"] = fontTtf;

            data['width'] = $("#lsd-editing-area").width();
            data['height'] = 1;

            data['custom-width'] = $("#canvas-custom-width").val();
            data['custom-height'] = $("#canvas-custom-height").val();

            //retrieve text color
            var text_color = $('#lsd-font-color').attr("data-color");
            data['text_color'] = text_color;

            //retrieve canvas color
            var canvas_color = $('#lsd-canvas-color').attr("data-color");
            data['canvas_color'] = canvas_color;
            data['unit'] = lsd.canvas_dimensions_unit;

            //verify if reverse is checked
            if ($('#lsd-reverse-cut').prop('checked')) {
                data['reverse'] = "true";
            } else {
                data['reverse'] = "false";
            }

            //alignment
            data['alignment'] = $('#lsd-text-alignment').attr("data-alignment");

            //letter spacing
            data['spacing'] = $("#lsd-spacing-range").val();

            return data;
        }


        //add design to cart
        $("#lsd-add-to-cart").on("click", function () {
            $.blockUI({message: lsd.translated_strings.loading_msg});
            var quantity = $(".lsd-quantity-field").val();
            var frm_data = lsd_retrieve_designer_data();
            var product_id = $(this).attr("data-id");
            if (typeof tpl === 'undefined') {
                var tpl = "";
            }
            frm_data["format"] = 'png';
            //frm_data["format"] = lsd.output_format;
            frm_data["tpl"] = tpl;
            frm_data["product_id"] = product_id;
            frm_data["quantity"] = quantity;
            var lsd_generate_design_nonce = $('#lsd_generate_design_nonce').val();
            $.post(
                    lsd_ajax_object.lsd_ajax_url,
                    {
                        action: "lsd_add_custom_design_to_cart",
                        data: frm_data,
                        lsd_generate_design_nonce: lsd_generate_design_nonce
                    },function (answer) {
                        var response = JSON.parse(answer);
                        $("#lsd-debug").html(response.message);
                        $.unblockUI();
                        if(lsd.redirect_after === "1"){
                            window.location.href = response.url;
                        }
                    });
        });
    });
})(jQuery);
